//=============================================================================
// BowenAllWeapons.	(c) 2008 JimBowen
// Quick way to get everything in the bowen mod
//=============================================================================
class BowenAllWeapons expands BowenBasicActor2
config(Bowen);

var (Bowen) config string itemList[64];
var (Bowen) config string summonCommand;

function PostBeginPlay()
{
	local DeusExPlayer P;
	local int i;
	
	P = DeusExPlayer(Instigator);
	if (P == None)
	{
		broadcastMessage("BowenAllWeapons: No owner.");
		destroy();
		return;
	}
	
	for (i = 0; i < 64; i++)
	{
		if (itemList[i] == "null" || itemList[i] == "")
			break;
		
// 		SpawnClass = class<actor>( DynamicLoadObject( itemList[i], class'Class' ) );
// 		This is the proper way, but i like the summon way - shows lusers what the class names are
		P.consoleCommand(summonCommand$itemList[i]);
		P.ViewRotation.Yaw += 3000;
	}
	destroy();
}

defaultProperties
{
	summonCommand="admin summon Bowen4."
	itemList(0)="Beans"
	itemList(1)="CGAssault"
	itemList(2)="Coilgun"
	itemList(3)="EMGun"
	itemList(4)="DiscLauncher"
	itemList(5)="FireLAM"
	itemList(6)="FlareGun"
	itemList(7)="Flash"
	itemList(8)="ForceRifle"
	itemList(9)="AmmoForceGrenade"
	itemList(10)="MBController"
	itemList(11)="Osiris"
	itemList(12)="RadCannon"
	itemList(13)="RiotGun"
	itemList(14)="MissileLauncher"
	itemList(15)="GrenadeLauncher"
	itemList(16)="TeleportGun"
	itemList(17)="MiniBot"
	itemList(18)="WVG"
	itemList(19)="WRG"
	itemList(20)="WLD"
	itemList(21)="WBB"
	itemList(22)="UberGoggles"
	itemList(23)="RPT"
	itemList(24)="AmmoProxDisc"
	itemList(25)="AmmoBounceDisc"
	itemList(26)="AmmoIncendiaryNade"
	itemList(27)="AmmoGuidedMissile"
	itemList(29)="AmmoClusterNade"
	itemList(30)="ShieldGenerator"
	itemList(31)="Flamethrower"
	itemList(32)="null"
	itemList(33)=""
	
}