//=============================================================================
// GrenadeLauncher. 	(c) 2008 JimBowen
//=============================================================================

class GrenadeLauncher extends BowenWeapon;

replication
{
	reliable if (Role == ROLE_Authority)
		DoSound;
}

function ScopeToggle()
{
	// hack so that players without configured ini files can still use the weapon
	// yes i know its ugly, but you think of a better way!
	Detonate();
}

function Detonate()
{
	local BowenNade Nade;
	DoSound();
	foreach allactors (Class'BowenNade', Nade)
	if(Nade != None)
	{
		if(Nade.Owner == Owner)
		{
			Nade.Detonate();
		}
	}
}

simulated function DoSound()
{
	Owner.PlaySound (Sound'DeusExSounds.Generic.Beep1', SLOT_None, 1024);
}

defaultproperties
{
     ProjectileClass=class'BowenNade'
     AmmoNames(0)=Class'AmmoBowenNade'
     AmmoNames(1)=Class'AmmoIncendiaryNade'
     AmmoNames(2)=Class'AmmoClusterNade'
     ProjectileNames(0)=Class'BowenNade'
     ProjectileNames(1)=Class'IncendiaryBall'
     ProjectileNames(2)=Class'ClusterBomb'
     LowAmmoWaterMark=4
     GoverningSkill=Class'DeusEx.SkillWeaponRifle'
     EnviroEffective=ENVEFF_Air
     Concealability=CONC_Visual
     ShotTime=0.300000
     reloadTime=3.000000
     HitDamage=5
     maxRange=2400
     AccurateRange=1200
     BaseAccuracy=0.600000
     AmmoNames(0)=Class'AmmoBowenNade'
     AreaOfEffect=AOE_Point
     recoilStrength=0.500000
     mpReloadTime=0.500000
     mpHitDamage=90
     mpBaseAccuracy=0.300000
     mpAccurateRange=1200
     mpMaxRange=1200
     mpReloadCount=5
     mpPickupAmmoCount=12
     bCanHaveModReloadCount=True
     bCanHaveModReloadTime=True
     bCanHaveModRecoilStrength=True
     AmmoName=Class'AmmoBowenNade'
     ReloadCount=5
     PickupAmmoCount=5
     bInstantHit=False
     FireOffset=(X=-11.000000,Y=4.000000,Z=13.000000)
     shakemag=50.000000
     AltFireSound=Sound'DeusExSounds.Weapons.SawedOffShotgunReloadEnd'
     CockingSound=Sound'DeusExSounds.Weapons.SawedOffShotgunReload'
     SelectSound=Sound'DeusExSounds.Weapons.SawedOffShotgunSelect'
     InventoryGroup=67
     ItemName="Grenade Launcher"
     PlayerViewOffset=(X=11.000000,Y=-4.000000,Z=-13.000000)
     PlayerViewMesh=LodMesh'DeusExItems.Shotgun'
     PickupViewMesh=LodMesh'DeusExItems.ShotgunPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.Shotgun3rd'
     LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconShotgun'
     largeIcon=Texture'DeusExUI.Icons.LargeIconShotgun'
     largeIconWidth=131
     largeIconHeight=45
     invSlotsX=3
     Description="The new grenade launcher from BowenCo"
     beltDescription="NADE"
     Mesh=LodMesh'DeusExItems.ShotgunPickup'
     CollisionRadius=12.000000
     CollisionHeight=0.900000
     Mass=15.000000
}