class RingTracer extends Tracer;

var float size;

simulated function Tick(float deltaTime)
{
	Super.Tick(DeltaTime);
	DrawScale = size * (Default.LifeSpan - LifeSpan) / Default.LifeSpan;
	ScaleGlow = LifeSpan / Default.LifeSpan;
}

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	if (size > 5)
		Skin = Texture'FlatFXTex43';
}

defaultproperties
{
     size=3.000000
     bCollideActors=False
     bCollideWorld=False
     bBlockActors=False
     bBlockPlayers=False
     LifeSpan=0.2500000
     DrawType=DT_Mesh
     Speed=1000
     Style=STY_Translucent
     Skin=Texture'DeusExItems.Skins.FlatFXTex41'
     Mesh=LodMesh'DeusExItems.FlatFX'
     bUnlit=True
}